'ConnectWhenReady.vbs: Wait until the specified station comes online, then connect to it.

'Author: Jonathan Taylor, K1RFD
'Date: July 23, 2003

'To invoke this script from the command line, type:
'	cscript ConnectWhenReady.vbs callsign
'where "callsign" is the callsign of the station to which to connect.
'This script should only be run if EchoLink is already running.


If WScript.Arguments.Count > 0 Then

	sStation = WScript.Arguments(0)

	'Instantiate EchoLink's Session component, and set up an event connection
	Set oEchoLink = WScript.CreateObject("EchoLink.EchoLinkSession", "EchoLink_")
	
	'get a fresh copy of the station list to kick things off
	oEchoLink.RefreshStationList True
	
	'is the desired station already online?
	If IsStationOnlineAndNotBusy(sStation) Then
		oEchoLink.Connect sStation, True
		WScript.Quit(0)
	Else
		'sleep and let events drive things from now on
		While True
			WScript.Sleep 1000
		Wend
	End If
End If


Sub EchoLink_Closing
	'EchoLink is shutting down; exit now to avoid picking daisies
	WScript.DisconnectObject(oEchoLink)
	Set oEchoLink = Nothing
	WScript.Quit(0)
End Sub


Sub EchoLink_StationListReceived

	'This event fires each time the Station List is refreshed.  Check the revised station list
	'for the desired callsign; go back to sleep if not found.
	
	If IsStationOnlineAndNotBusy(sStation) Then
		oEchoLink.Connect sStation, True
		WScript.Quit(0)
	End If
End Sub


Function IsStationOnlineAndNotBusy(sStation)

	IsStationOnline = False
	
	'Walk through the current station list, looking for the desired callsign and its status.

	Set oStations = oEchoLink.StationEntries
	For Each oStation In oStations
		If oStation.Callsign = sStation And oStation.Status = "ON" Then
			IsStationOnlineAndNotBusy = True
			Exit For
		End If
	Next 

End Function
	
